<?php

if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) {	die( 'Direct Access to this location is not allowed.' ); }

//
// [TODO] At the moment SimplePie V1.0 is integrated with Joomla. This version is buggy and missing some features.
// When the new version is integrated some improvements can be done...
// missing functions: set_item_limit($mfdMaxEntrys), get_contributor() 
// Also the multifeed sorting does not working for entrys without date.  
//
jimport('simplepie.simplepie');

class BlogTab extends cbTabHandler {
	
	function BlogTab() {
		return $this->cbTabHandler();
	}

	function getDisplayTab($tab, $user, $ui) {
		global $_CB_framework, $_PLUGINS;
		
		// plugin and tab parameters
		$params = $this->params;
		$fdEnableCache      = $params->get('fdEnableCache', 1);
		$fdCacheTime		= $params->get('fdCacheTime', 10) * 60; // minutes to seconds
		$bfdMaxEntrys		= $params->get('bfdMaxEntrys', 10);
		$bfdShowDesc		= $params->get('bfdShowDesc', 0);		
		$bfdShowDate		= $params->get('bfdShowDate', 1);
		$bfdLineBackground	= $params->get('bfdLineBackground', 1);
		$bfdShowBlogTitle	= $params->get('bfdShowBlogTitle', 1);		
		$bfdShowBlogImage	= $params->get('bfdShowBlogImage', 1);		
		$bfdShowBlogDesc	= $params->get('bfdShowBlogDesc', 1);		

		$fdAuthorLink		= '1';
	
		// user fields
		$bfdFeedURL			= $user->bfdFeedURL;	

		// div vars
		$live_site			= $_CB_framework->getCfg('live_site');
		$html				= '';
		
		// access to feed
		if ('' != $bfdFeedURL) {
			$bloginfo_html = '';
			$feedline_html = '';
			$feed = null;
			try {
				$feed = $this->getFeed($bfdFeedURL, $fdEnableCache, $fdCacheTime);
			}
			catch (Exception $e) { 
				$_PLUGINS->raiseError(0);
				$_PLUGINS->_setErrorMSG($e->getMessage());

			}
		
			// generate html output
			if (null != $feed) {
				// head with blogfeed info
				if ($bfdShowBlogTitle || $bfdShowBlogImage || $bfdShowBlogDesc) {
					$bloginfo_html .= '<div class="fdhead">';
					if ($bfdShowBlogImage) {
						$bloginfo_html .= '<a href="' . $feed->get_image_link() . '" title="' . $feed->get_image_title() . '"><img src="' . $feed->get_image_url() . '" width="' . $feed->get_image_width() . '" height="' . $feed->get_image_height() . '" /></a>';
					}
					if ($bfdShowBlogTitle) {
						$bloginfo_html .= '<a href="' . $feed->get_permalink() . '" target="_blank">' . $feed->get_title() . '</a>';
					}
					if ($bfdShowBlogDesc) {	$bloginfo_html .= '<p>' . strip_tags($feed->get_description()) . '</p>'; }
					$bloginfo_html .= '</div>';
				}				

				// feed timeline
				if ($feed->get_item_quantity() > 0) {
					$cnt = 0;
					$now =& JFactory::getDate();
					$entrys = $feed->get_items(0, $bfdMaxEntrys); 
					
					foreach ($entrys as $entry) {
						$cnt++;
						// set background style for entry
						if (0 != ($cnt % 2) && $bfdLineBackground) {
							$fditem = 'fditem_color';
						}
						else {
							$fditem = 'fditem';						
						}
						
						$feedline_html .= '<div class="' . $fditem . '">';
						$feedline_html .= '<a href="' . $entry->get_permalink() . '" target="_blank">' . $entry->get_title() . '</a>' . '<br/>';
						if ($bfdShowDate) {
							$date = JFactory::getDate(strtotime($entry->get_date()) + ($now->toUnix() - time()));
							$feedline_html .= '<p>' . JHTML::_('date', $date->toUnix(), JText::_('DATE_FORMAT_LC2')) . '</p>'; 
						}
						if ($bfdShowDesc) {
							$feedline_html .= '<p>' . strip_tags($entry->get_content()) . '</p>';
						}	
						$feedline_html .= '</div>';
					}
				}
			}	
			
			// add style sheet
			$_CB_framework->document->addHeadStyleSheet( $live_site . '/components/com_comprofiler/plugin/user/plug_multifeedtab/multifeed.tab.css' );
					
			$html .= $bloginfo_html . $feedline_html;
			if($fdAuthorLink) {
				$html .= '<p>&nbsp;</p><div style="font-size: 9px;" align="center">Powered by <a style="font-size: 10px;" href="http://www.1st-movers.com" title="1stMovers" target="_blank">1st-movers.com</a></div>';
			}		
		}
		elseif ($_CB_framework->_myId == $user->id) {
			// show message for logged in users without blog
			$html .= '<p><a href="' . $this->getUserDetailsPath($tab->tabid) . '">Activate your blog feed</a> and show your blogline in your profile.</p>';
		}
				
		return $html;
	}
	

	private function getFeed($bfdFeedURL, $fdEnableCache, $fdCacheTime)
	{
		$feed = new SimplePie();
		$feed->set_feed_url($bfdFeedURL);
		$feed->set_useragent('1st-movers.com'); // Workaround for feedburner
		
		if ($fdEnableCache) {
			$feed->enable_cache(true);
			$feed->set_cache_duration($fdCacheTime);
		}
		else {
			$feed->enable_cache(false);
		}
		
		$feed->init();
		$feed->handle_content_type();
		
		return $feed;
	}
	
	protected function getUserDetailsPath($tabid)
	{
		return cbSef( 'index.php?option=com_comprofiler' . getCBprofileItemid(true, false) . '&task=userDetails&tab=' . (int)$tabid );
	}
}



class MultifeedTab extends cbTabHandler {
	
	function MultifeedTab() {
		return $this->cbTabHandler();
	}

	function getDisplayTab($tab, $user, $ui) {
		global $_CB_framework, $_PLUGINS;
		
		// plugin and tab parameters
		$params = $this->params;
		$fdEnableCache      = $params->get('fdEnableCache', 1);
		$fdCacheTime		= $params->get('fdCacheTime', 10) * 60; // minutes to seconds
		$mfdMaxEntrys		= $params->get('mfdMaxEntrys', 20);
		$mfdShowIcon		= $params->get('mfdShowIcon', 1);
		$mfdShowDesc		= $params->get('mfdShowDesc', 0);		
		$mfdShowDate		= $params->get('mfdShowDate', 1);
		$mfdLineBackground	= $params->get('mfdLineBackground', 1);
	
		$fdAuthorLink		= '1';
	
		// user fields
		$mfdFeedURL			= $user->mfdFeedURL;	

		// div vars
		$live_site			= $_CB_framework->getCfg('live_site');
		$html				= '';
		
		// access to feed
		$feed_url = $this->getFeedURL($mfdFeedURL);
		if ($feed_url) {
			$feedline_html = '';
			$feed = null;
			try {
				$feed = $this->getFeed($feed_url, $mfdMaxEntrys, $fdEnableCache, $fdCacheTime);
			}
			catch (Exception $e) { 
				$_PLUGINS->raiseError(0);
				$_PLUGINS->_setErrorMSG($e->getMessage());

			}
		
			// generate html output
			if (null != $feed) {
				$cnt = 0;
				$now =& JFactory::getDate();
				//$entrys = $feed->get_items(0, $mfdMaxEntrys); 
				
				foreach ($feed as $entry) {
					$cnt++;
					// set background style for entry
					if (0 != ($cnt % 2) && $mfdLineBackground) {
						$fditem = 'fditem_color';
					}
					else {
						$fditem = 'fditem';						
					}
					$feedline_html .= '<div class="' . $fditem . '">';
					if ($mfdShowIcon) {
						// $entry->get_feed()->get_image_title() is only a workaround for missing feature getContributor()  in V1.0
						$feedline_html .= '<img src="' . $entry->get_feed()->get_favicon() . '" title="' . $entry->get_feed()->get_title() . '" alt="' . $entry->get_feed()->get_image_title() . ':" class="fdimg" />';		
					}
					$feedline_html .= '<a href="' . $entry->get_permalink() . '" target="_blank">' . $entry->get_title() . '</a>';
					$feedline_html .= '<br/>';
					if ($mfdShowDate) {
						$date = JFactory::getDate(strtotime($entry->get_date()) + ($now->toUnix() - time()));
						$feedline_html .= '<p>' . JHTML::_('date', $date->toUnix(), JText::_('DATE_FORMAT_LC2')) . '</p>'; 
					}
					if ($mfdShowDesc) {
						$feedline_html .= '<p>' . strip_tags($entry->get_content()) . '</p>';
					}	
					$feedline_html .= '</div>';
				}
			}	
			
			// add style sheet
			$_CB_framework->document->addHeadStyleSheet( $live_site . '/components/com_comprofiler/plugin/user/plug_multifeedtab/multifeed.tab.css' );
					
			$html .= $feedline_html;
			if($fdAuthorLink) {
				$html .= '<p>&nbsp;</p><div style="font-size: 9px;" align="center">Powered by <a style="font-size: 10px;" href="http://www.1st-movers.com" title="1stMovers" target="_blank">1st-movers.com</a></div>';
			}		
		}
		elseif ($_CB_framework->_myId == $user->id) {
			// show message for logged in users without blog -- TODO: oder doch besser kein Tab in diesem Fall
			$html .= '<p><a href="' . $this->getUserDetailsPath($tab->tabid) . '">Activate your feeds</a> and show they in your profile.</p>';
		}
				
		return $html;
	}

	
	private function getFeedURL($mfdFeedURL)
	{
		$url_list = null;
		$url_str = trim($mfdFeedURL, "" );		
		if ('' != $url_str) {
			$url_list = explode(',', $url_str);
		}		
		return $url_list;
	}

	
	private function getFeed($feed_url, $mfdMaxEntrys, $fdEnableCache, $fdCacheTime)
	{
	    $feed = null;
		
		// Multifeed sorting does not working for entrys without date.
		// So we must handle feeds separatly, remove feeds with missing date information and call merging function directly
		// in a newer release this can be done by SimnplePie itself (i hope so)
		$feedList = array();
		foreach ($feed_url as $feedURL) {
			$tmpFeed = new SimplePie();
			$tmpFeed->set_feed_url($feedURL);
			$tmpFeed->set_useragent('1st-movers.com'); // Workaround for feedburner
			if ($fdEnableCache) {
				$tmpFeed->enable_cache(true);
				$tmpFeed->set_cache_duration($fdCacheTime);
			}
			else {
				$tmpFeed->enable_cache(false);
			}			
			$tmpFeed->init();
			$tmpFeed->handle_content_type();			
			$tmpItem = $tmpFeed->get_item();
			if ((null != $tmpItem) && (null != $tmpItem->get_date())) {
				$feedList[] = $tmpFeed;
			}
		}
		
		if (count($feedList) > 0) {
			$feed = SimplePie::merge_items($feedList, 0, $mfdMaxEntrys);		
		}

		return $feed;
	}
	
	protected function getUserDetailsPath($tabid)
	{
		return cbSef( 'index.php?option=com_comprofiler' . getCBprofileItemid(true, false) . '&task=userDetails&tab=' . (int)$tabid );
	}
}

?>